CodeForces

来源:互联网 发布:阿里云湖南一级代理 编辑:程序博客网 时间:2024/06/05 19:32

A. Flipping Game

time limit per test1 second
memory limit per test256 megabytes
inputstandard input
outputstandard output
Iahub got bored, so he invented a game to be played on paper.

He writes n integers a1, a2, …, an. Each of those integers can be either 0 or 1. He’s allowed to do exactly one move: he chooses two indices i and j (1 ≤ i ≤ j ≤ n) and flips all values ak for which their positions are in range [i, j] (that is i ≤ k ≤ j). Flip the value of x means to apply operation x = 1 - x.

The goal of the game is that after exactly one move to obtain the maximum number of ones. Write a program to solve the little game of Iahub.

Input
The first line of the input contains an integer n (1 ≤ n ≤ 100). In the second line of the input there are n integers: a1, a2, …, an. It is guaranteed that each of those n values is either 0 or 1.

Output
Print an integer — the maximal number of 1s that can be obtained after exactly one move.

Examples
input
5
1 0 0 1 0
output
4
input
4
1 0 0 1
output
4
Note
In the first case, flip the segment from 2 to 5 (i = 2, j = 5). That flip changes the sequence, it becomes: [1 1 1 0 1]. So, it contains four ones. There is no way to make the whole sequence equal to [1 1 1 1 1].

In the second case, flipping only the second and the third element (i = 2, j = 3) will turn all numbers into 1.

题意:

可以对一段区间里的01取反一次,n<=100,
1.暴力枚举区间在计算答案O(n^3)

2.暴力枚举区间前缀和优化算答案O(n^2)

3.观察每次用前缀和计算[L,R]答案(ai记录1-i中,1的个数,bi记录1-i中,0的个数)
ans=a[L-1]+a[n]-a[R]+a[R]-b[L-1];
现在考虑以R为右端点的区间,a[n]-a[R]+b[R]这一部分始终是相同的,所以我们只要找到a[L-1]-b[l-1]这段区间的最大值即可,而这个最大值可以直接开一个变量维护
复杂度O(n)

O(n^2)代码

#include<cstdio>#include<cstring>#include<algorithm>#include<cmath>#include<iostream>using namespace std;const int maxn=1e5+5;int a[maxn],b[maxn],n,x;int main(){  while(~scanf("%d",&n))  {    for(int i=1;i<=n;++i)    {      scanf("%d",&x);      a[i]=a[i-1]+(x==1);      b[i]=b[i-1]+(x==0);    }    int ans=0;    for(int i=1;i<=n;++i)      for(int j=i;j<=n;++j)      ans=max(ans,a[i-1]+a[n]-a[j]+b[j]-b[i-1]);    //for(int i=1;i<=n;++i)printf("a=%d b=%d\n",a[i],b[i]);    printf("%d\n",ans);  }  return 0;}

O(n)代码

#include<cstdio>#include<cstring>#include<algorithm>#include<cmath>#include<iostream>using namespace std;const int maxn=1e5+5;int a[maxn],b[maxn],n,x;int main(){  while(~scanf("%d",&n))  {    for(int i=1;i<=n;++i)    {      scanf("%d",&x);      a[i]=a[i-1]+(x==1);      b[i]=b[i-1]+(x==0);    }    int ans=0,res=0;    for(int i=1;i<=n;++i)    {      ans=max(ans,res+a[n]-a[i]+b[i]);      if(a[i]-b[i]>res)res=a[i]-b[i];    }    //for(int i=1;i<=n;++i)printf("a=%d b=%d\n",a[i],b[i]);    printf("%d\n",ans);  }  return 0;}
原创粉丝点击